#ifndef _DLGS_H
#define _DLGS_H

// kbukint : United Kingdom International Keyboard Layout for 9x and NT OSs
//   (c) 2004 John Sullivan
//
// Dialogs for reinstall/uninstalls
//

#include "kbgen.h"
#include "resource.h"


class CAlreadyDlg : public CDialogImpl<CAlreadyDlg>
{
public:
    CAlreadyDlg(LPCTSTR kbdPath)
    {
        m_path = kbdPath;
    }

    CString m_path;

	enum { IDD = IDD_ALREADY };

	BEGIN_MSG_MAP(CAlreadyDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(ID_REPAIR, OnCloseCmd)
		COMMAND_ID_HANDLER(ID_INSTALL, OnCloseCmd)
		COMMAND_ID_HANDLER(ID_UNINSTALL, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
        CString str;
        str.LoadString(IDS_ALREADYINSTALLED);

        CString str2;
        str2.Format(str, m_path);

        SetDlgItemText(IDC_STATIC_ALREADY, (LPCSTR)str2);

		return TRUE;
	}

	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}
};

class CUninstallDlg : public CDialogImpl<CUninstallDlg>
{
public:
    CUninstallDlg(bool bNT)
    {
        m_bNT = bNT;
    }

    bool m_bNT;

	enum { IDD = IDD_UNINSTALL };

	BEGIN_MSG_MAP(CUninstallDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
        GetInstalledKBDs(GetDlgItem(IDC_LIST_KBDS), m_bNT);
		return TRUE;
	}

	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
        HWND hLB = GetDlgItem(IDC_LIST_KBDS);

        int cnt = SendMessage(hLB, LB_GETCOUNT, 0, 0);
        for ( int i=0 ; i<cnt ; i++ ) {
            int rv = SendMessage(hLB, LB_GETSEL, i, 0);
            if (rv && rv!=LB_ERR) {
                UninstallKBD(SendMessage(hLB, LB_GETITEMDATA, i, 0));
            }
        }

		EndDialog(wID);
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}
};


#endif /* _DLGS_H */
