#ifndef _KBGEN_H
#define _KBGEN_H

// kbukint : United Kingdom International Keyboard Layout for 9x and NT OSs
//   (c) 2004 John Sullivan
//
// Generate and register a Win9x .KBD file or NT keyboard layout DLL
//

// For testing the KBD generation on non-9x OSs
//#define GENTEST 1

// Detects previous installations, and returns path to existing file
int KBDInstalled(LPTSTR kbdFullPath, bool bNT);

#define KBD_NOTINSTALLED 0
#define KBD_INSTALLED 1
#define KBD_PARTIAL 2

// Returns true if successfully installed
bool InstallKBD(bool bInPlace, bool bNT); 

// Fills a LISTBOX with the currently registered instances of this layout
bool GetInstalledKBDs(HWND hLB, bool bNT);

// Removes a layout registration
bool UninstallKBD(DWORD dwLayoutId);

#endif /* _KBGEN_H */
