// kbukint9x.cpp : United Kingdom International Keyboard Layout for 9x OSs
//   (c) 2004 John Sullivan
//
// Main application control
//

#include "stdafx.h"

#include "kbgen.h"
#include "dlgs.h"

#include "resource.h"

CAppModule _Module;

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

    int nRet = 0;

    CString strCap;
    strCap.LoadString(IDS_APP_CAPTION);

    OSVERSIONINFO ovi;
    memset(&ovi, 0, sizeof(ovi));
    ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&ovi);

#ifdef GENTEST
    bool isNT = false;
#else
    bool isNT = (ovi.dwPlatformId==VER_PLATFORM_WIN32_NT);
#endif

//    if (isNT) {
//        CString str;
//        str.LoadString(IDS_WRONGOS);
//        MessageBox(NULL, str, strCap, MB_OK|MB_ICONSTOP);
//        nRet = 1;
//    } else {
        CString str;
        int rv = IDNO;
        bool bInPlace = false;
        TCHAR kbdPath[MAX_PATH];

        if (KBDInstalled(kbdPath, isNT)) {
            CAlreadyDlg dlg(kbdPath);
            rv = dlg.DoModal();

            if (rv==ID_UNINSTALL) {
                CUninstallDlg dlg2(isNT);
                dlg2.DoModal();
                rv = IDCANCEL;
            }

            if (rv==ID_REPAIR || rv==ID_INSTALL) {
                bInPlace = (rv==ID_REPAIR);
                rv = IDYES;
            }
        } else {
            str.LoadString(IDS_PROCEED);
            rv = MessageBox(NULL, str, strCap, MB_YESNO|MB_ICONWARNING);
        }

        if (rv==IDYES) {
            bool bInstOK = InstallKBD(bInPlace, isNT);

            str.LoadString(bInstOK ? IDS_INSTOK : IDS_INSTFAIL);
            MessageBox(NULL, str, strCap, MB_OK|(bInstOK ? MB_ICONINFORMATION : MB_ICONSTOP));

            nRet = bInstOK ? 0 : 1;
        }
//    }

	_Module.RemoveMessageLoop();
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_COOL_CLASSES | ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}
